import PCancelable from 'p-cancelable';
import { ExecutionError, IConnection, INode, INodeExecutionData, IPinData, IRun, IRunData, IRunExecutionData, IWorkflowExecuteAdditionalData, Workflow, WorkflowExecuteMode } from 'n8n-workflow';
export declare class WorkflowExecute {
    runExecutionData: IRunExecutionData;
    private additionalData;
    private mode;
    constructor(additionalData: IWorkflowExecuteAdditionalData, mode: WorkflowExecuteMode, runExecutionData?: IRunExecutionData);
    run(workflow: Workflow, startNode?: INode, destinationNode?: string, pinData?: IPinData): PCancelable<IRun>;
    runPartialWorkflow(workflow: Workflow, runData: IRunData, startNodes: string[], destinationNode: string, pinData?: IPinData): PCancelable<IRun>;
    executeHook(hookName: string, parameters: any[]): Promise<void>;
    incomingConnectionIsEmpty(runData: IRunData, inputConnections: IConnection[], runIndex: number): boolean;
    addNodeToBeExecuted(workflow: Workflow, connectionData: IConnection, outputIndex: number, parentNodeName: string, nodeSuccessData: INodeExecutionData[][], runIndex: number): void;
    processRunExecutionData(workflow: Workflow): PCancelable<IRun>;
    processSuccessExecution(startedAt: Date, workflow: Workflow, executionError?: ExecutionError, closeFunction?: Promise<void>): Promise<IRun>;
    getFullRunData(startedAt: Date): IRun;
}
